#include <iostream>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <main.h>

using namespace std;

// Example of how to use pipes to connect output from one process
// to input of another process.
int main(void)
{
  int pid;
  int thePipe[2];

  pipe(thePipe);
  pid = fork();

  // Error ocurred
  if (pid < 0) {
    cerr << "main: Fork failed!" << endl;
    exit(-1);
  }

  // CONSUMER: child process executes grep command
  else if (pid == 0) {

    close(0);            // close stdin
    dup(thePipe[0]);     // copy thePipe's input end to stdin
    close(thePipe[0]);   // don't need thePipe input end anymore
    close(thePipe[1]);   // not using thePipe output end

    execlp("/bin/grep","grep","pox",NULL);
  }

  // PRODUCER: parent process executes cat command
  else {

    close(1);           // close stdout
    dup(thePipe[1]);    // copy thePipe's output end to stdout
    close(thePipe[0]);  // don't need thePipe input end
    close(thePipe[1]);  // don't need thePipe output end anymore

    execlp("/bin/cat","cat","romeojuliet.txt",NULL);
  }

  return 1;
}
